; overlay area
$nomod51
$nolist
$include (..\inc\ch552_keil.h)
$list
dseg at 0x08
;these is overlay data
RAM_08:            ds 1 
RAM_09:            ds 1
RAM_0A:            ds 3
; ptr memcpy source
RAM_0D:            ds 3
; memcpy size      
RAM_10:            ds 1

RAM_11:            ds 4;

bseg at 0
bWrProtect:        DBIT 1     ; 1 disables CodeFlash writing
bSoftReset:        DBIT 1     ; 1 for Software reset
bFirstSer:         DBIT 1     ; 1 for first serial 
bReqError:         DBIT 1     ; 1 on request Errors  

dseg at 0x21
wValueLo:          ds 1       ; 0x21   
BootKey:           ds 8       ; 0x22 
Marker0:           ds 1       ; 0x2A
rlen:              ds 1       ; 0x2B   
reqlen:            ds 1       ; 0x2C
cmdbuffer:         ds 64      ; 0x2D 
                   ds 2       ; 0x6d spare                 
bRequest:          ds 1       ; 0x6F
SnSum:             ds 1       ; 0x70
DescAddr:          ds 2       ; 0x71
CAddr:             ds 2       ; 0x73
Marker1:           ds 1
STACK:

xseg at 0
EP0_BUFFER:        ds  8      ; 0x0000 the control endpoint
                   ds  4      ; spare
EP2_BUFFER:        ds 64      ; 0x000C bulk out
Response:          ds 64      ; 0x004C bulk in

StartAddress      equ  0x3000

cseg at StartAddress          ; bootloader at 0x3800

   ljmp  C_C51STARTUP
   nop  

; =============== S U B R O U T I N E =======================================
FunctionDispatcher:           ; 0x3804

_i      set R3                ;
_result set R1
_len    set RAM_0A
_addr   set RAM_0A+1
    mov    A, Marker1         ; 
    xrl    A, #0x5A
    jz     $+4
    sjmp   $                  ;

    clr    A                  ;
    mov    DPTR, #Response + 5;Response[5]=0;
    movx   @DPTR, A           ;

    mov    rlen, #6           ;
    mov    _result, #0xFE     ;result = -2
    mov    A, cmdbuffer+0     ;switch (cmdbuffer[0])
    add    A, #0x5F           ;
    cjne   A, #11, code_381D  ; 11 functions

code_381D:                    ;
    jc    ComandCodeValid
    ljmp  FuncBreak           ; unknown cmd

ComandCodeValid:              ;
    mov   DPTR, #JmpTable
    mov   B, #3               ; size of ljmp
    mul   AB
    xch   A, DPH              ; calc the offset into
    add   A, B                ; table
    xch   A, DPH              ;
    jmp   @A+DPTR             ; vector jmp

JmpTable:                     ;
    ljmp  JumpFunction0       ;a1 detect chip V2  
    ljmp  JumpFunction1       ;a2 BootControl
    ljmp  JumpFunction2       ;a3 createkey
    ljmp  JumpFunction3       ;a4 erase Code Flash  (2k page)
    ljmp  JumpFunction4       ;a5 write  encoded code flash
    ljmp  JumpFunction5       ;a6 verify encoded code flash
    ljmp  JumpFunction6       ;a7 read  Boot Options 
    ljmp  JumpFunction7       ;a8 write Boot Options
    ljmp  JumpFunction8       ;a9 erase Data Flash
    ljmp  JumpFunction9       ;aa write encoded data flash
    ljmp  JumpFunction10      ;ab read data flash 
;*****************************;
JumpFunction0:                ;
    mov   _result, CHIP_ID    ; 
    clr   A                   ; 
    mov   _i, A               ;for (i=0,i<16 i++)  
Func0Loop:                    ;
    mov   A, _i               ;{ 
    mov   DPTR, #CopyrightMsg
    movc  A, @A+DPTR          ;  
    mov   R7, A
    mov   A, #cmdbuffer + 5   ;  
    add   A, _i               ;  if (CopyrightMsg[i] != cmdbuffer[5+i]) 
    mov   R0, A               ;  
    mov   A, @R0              ; 
    xrl   A, R7               ;
    jz    Func0Next           ;  {
    mov   _result, #0xF1      ;     result = 0xF1 
    ljmp  FuncBreak           ;     break; 
Func0Next:                    ;  } 
    inc   _i
    cjne  _i, #0x10, Func0Loop;}

    mov   DPTR, #Response + 5 ; Response[5]=0x11;
    mov   A, #0x11            ;
    movx  @DPTR, A            ;
    ljmp  FuncBreak           ;break;
;*****************************;
JumpFunction4:                ;
    jnb   bWrProtect, JumpFunction9;
    ljmp  Dispatcher_Done     ;return
;*****************************
;<a5> <len> <0> <addrL> <addrH> <data[len+5]>
;<aa> <len> <0> <addrL> <addrH> <data[len+5]>
JumpFunction9:                ;
    mov   A, cmdbuffer+1      ; len = cmdbuffer[1]-5
    add   A, #-5              ;  
    mov   _len, A           ; 
    mov   A, cmdbuffer+4      ; R6/R5 = cmdbuffer[4]<< 8 | cmdbuffer[3]
    mov   R6, A               ; 
    mov   A, cmdbuffer+3
    mov   R5, A

    mov   A, R6               ; store Param
    mov   _addr, A
    mov   A, R5
    mov   _addr+1, A

    mov   A, cmdbuffer+0      ; if (cmdbuffer[0] == 0xA5)
    xrl   A, #0xA5
    jnz   code_38E2           ; {

    mov   _i, A               ;    for (i=0; i < len; i+=2)
code_3894:                    ;    {
    mov   A, _i
    clr   C
    subb  A, _len
    jc    $+5
    ljmp  FuncBreak

    mov   A, _i 
    mov   R6, #0              ;        R6/R7 = param +i
    add   A, _addr+1        
    mov   R7, A
    mov   A, R6
    addc  A, _addr
    mov   R6, A
    mov   A, R6
    push  ACC                 ;         save it 
    mov   A, R7
    push  ACC                 ; 
    mov   A, _i
    anl   A, #7
    mov   R5, A               ;         R5 = i & 0x07
    add   A, #BootKey+1       ; 
    mov   R0, A
    mov   A, @R0
    mov   R7, A               ;         R7 = Bootkey[1+i&7]
    mov   A, #cmdbuffer+9     ; 
    add   A, _i
    mov   R0, A
    mov   A, @R0
    xrl   A, R7
    mov   R6, A              ;          R6 = cmdbuffer[9+i] ^ Bootkey[1+i&7]  
    mov   A, #BootKey+0      ;          
    add   A, R5
    mov   R0, A
    mov   A, @R0
    mov   R5, A              ;          R5 = Bootkey[0+i]
    mov   A, #cmdbuffer+8    ;
    add   A, _i
    mov   R0, A
    mov   A, @R0
    xrl   A, R5
    mov   R5, A             
    mov   A, R6
    mov   R4, A              ;          R4 =  cmdbuffer[8+i] ^ Bootkey[0+i]
    pop   ACC                ; 
    mov   R7, A
    pop   ACC                ; 
    mov   R6, A
    lcall WriteFlashCode
    xch   A, _result
    mov   A, R7
    xch   A, _result
    mov   A, _result
    jz    code_38DE
    ljmp  FuncBreak
code_38DE:                   ;
    inc   _i
    inc   _i
    sjmp  code_3894

code_38E2:                    ; else
    clr   A                   ; {
    mov   _i, A               ;    i=0

code_38E4:                    ;    for (i=0; i < _len; i++)
    mov   A, _i               ;
    clr   C
    subb  A, _len
    jc    code_38ED
    ljmp  FuncBreak
code_38ED:                    ;    {
    mov   A, _addr+1
    add   A, _i
    mov   R7, A
    mov   A, _i
    anl   A, #7
    add   A, #BootKey+0       ;
    mov   R0, A
    mov   A, @R0
    mov   R6, A
    mov   A, #cmdbuffer+8      ;0x35 ; '5'
    add   A, _i
    mov   R0, A
    mov   A, @R0
    xrl   A, R6

code_38FF:        ; 
    mov   R5, A
    lcall WriteFlashData
    xch   A, _result
    mov   A, R7
    xch   A, _result
    mov   A, _result
    jz    code_390C
    ljmp  FuncBreak

code_390C:                    ;
    inc   _i                  ; i ++
    sjmp  code_38E4           ; loopit
    
;****************************;
;verify: <a6> <len> <0> <adrl> <adrh> <data[len-5]>
JumpFunction5:               ;
    mov   A, cmdbuffer+1     ;len= cmdbuffer[1]-5
    add   A, #-5             ;
    mov   _len, A            ;if (len & 0x07) break;
    anl   A, #7              ;
    jz    code_391C
    ljmp  FuncBreak

code_391C:                   ;
    mov   A, cmdbuffer+4     ; cmdbuffer[4]<< 8 | cmdbuffer[3]
    mov   R6, A
    mov   A, cmdbuffer+3
    mov   R5, A
    mov   A, R5
    mov   CAddr+0, R6       ; 
    mov   CAddr+1, A
    clr   A                  ;for (i=0,i < len i++) 
    mov   _i, A
code_3929:                   ;{
    mov   A, _i
    clr   C
    subb  A, _len
    jnc   code_3959          ;
    mov   A, _i              ;    if ( BootKey[i & 0x07]   
    anl   A, #7
    add   A, #BootKey+0      ; 
    mov   R0, A
    mov   A, @R0             ; 
    mov   R7, A
    mov   A, #cmdbuffer+8    ;       ^ cmdbuffer[8+i] 
    add   A, _i
    mov   R0, A
    mov   A, @R0             ;   
    xrl   A, R7              
    mov   R7, A              ;       ^ CBYTE[flashaddr]
    mov   DPL, CAddr+1      ; 
    mov   DPH, CAddr+0      ; 
    clr   A
    movc  A, @A+DPTR
    xrl   A, R7              ;        ) 
    jz    code_394E          ;        { 
    mov   _result, #0xF5     ;           result = 0xF5:
    ljmp  FuncBreak          ;           break;  
code_394E:                   ;        }           
    inc   CAddr+1           ; 
    mov   A, CAddr+1
    jnz   code_3956
    inc   CAddr+0
code_3956:                   ;loop ++
    inc   _i       
    sjmp  code_3929
code_3959:                   ;
    clr   A                  ; 
    mov   _result, A         ;result = 0 
    ljmp  FuncBreak
;****************************
;read dataflash
;<ab> <x> <x> <addrl> <addrh> <x> <x> <rlen> <data[rlen]>
JumpFunction10:              ;
    mov   A, cmdbuffer+7     ;rlen+=Buffer[7]
    add   A, rlen
    mov   rlen, A
    mov   ROM_ADDR_H, #high DATA_FLASH_ADDR
    mov   _i, #6             ;for (i= 6;i< rlen; i++)
code_3969:                   ;{
    mov   A, _i              
    clr   C                  
    subb  A, rlen            
    jnc   code_398B          
    mov   A, cmdbuffer+3     ;    (cmdbuffer[3+i] - 6) << 1
    add   A, _i              ; 
    add   A, #-6             ; 
    add   A, ACC             ; 
    mov   ROM_ADDR_L, A      ;
    mov   ROM_CTRL, #ROM_CMD_READ;  
    mov   A, #low Response   ;    Response[i]
    add   A, _i              ;
    mov   DPL, A             ;
    clr   A                  
    addc  A, #high Response  ;
    mov   DPH, A             ;
    mov   A, ROM_DATA_L      ; 
    movx  @DPTR, A           
    inc   _i                 
    sjmp  code_3969          ;}
code_398B:                   ;
    clr   A                  ; result = 0
    mov   _result, A              
    ljmp  FuncBreak          ; break
    
;****************************
;<a4> <x> <x> <page>
;This code does not work as expected
JumpFunction3:              ;  delete rom page
    mov   A, cmdbuffer+3    ; if (cmdbuffer[3] > 8) break
    clr   C
    subb  A, #8
    jnc   code_399A
    ljmp  FuncBreak

code_399A:                  ;
    mov   cmdbuffer+3, #4
    clr   A
    mov   _addr, A         ;addr=0
    mov   _addr+1, A

code_39A2:                  ;
    mov   A, #0xFF
    mov   R5, A
    mov   R4, A
    mov   R7, _addr+1
    mov   R6, _addr
    lcall WriteFlashCode     ;result=WriteFlashCode(addr,0xFFFF)
    xch   A, _result
    mov   A, R7
    xch   A, _result
    mov   A, #4              
    add   A, _addr+1        ;addr+=4 //why + 4
    mov   _addr+1, A
    clr   A
    addc  A, _addr
    mov   _addr, A          ;if (addr > 0x03FF) cmdbuffer[3]--;
    anl   A, #3
    orl   A, _addr+1
    jnz   code_39C3
    dec   cmdbuffer+3

code_39C3:                    ;
    mov   A, cmdbuffer+3      ;while (cmdbuffer[3])
    jnz   code_39A2
    clr   bWrProtect
    ljmp  FuncBreak
;*****************************
;<a9> 
JumpFunction8:                ;Erase FlashData
    clr   A
    mov   _i, A               ;for (i=0;i<128;i++)    

code_39CE:            ;
    xch   A, R7
    mov   A, _i
    xch   A, R7
    mov   R5, #0xFF
    lcall WriteFlashData
    xch   A, _result
    mov   A, R7
    xch   A, _result
    inc   _i
    cjne  _i, #0x80, code_39CE ; ''
    ljmp  FuncBreak
    
;*****************************
;new bootkey
;<a3> <len> <x> <>
JumpFunction2:              ;
    mov   A, cmdbuffer+1    ;if(cmdbuffer[1] < 30) break;
    clr   C
    subb  A, #0x1E
    jnc   $+5
    ljmp  FuncBreak

    mov   A, cmdbuffer+1     ;i= (Buffer[1] / 7)
    mov   B, #7              ; 
    div   AB
    mov   _i, A              ;
    add   A, ACC             ;cmdbuffer[3+i*4]
    add   A, ACC             ; 
    add   A, #cmdbuffer+3    ;
    mov   R0, A
    mov   A, @R0             ;
    xrl   A, SnSum
    mov   BootKey+0, A       ;BootKey[0] = cmdbuffer[3+i*4] ^ SnSum;
    mov   A, #cmdbuffer+3    ;
    add   A, _i
    mov   R0, A
    mov   A, @R0
    xrl   A, SnSum
    mov   BootKey+2, A       ;BootKey[2] = cmdbuffer[3+i] ^ SnSum;
    mov   A, _i              ;
    mov   B, #6              ; 
    mul   AB
    add   A, #cmdbuffer+3    ;cmdbuffer[3+i*6]
    mov   R0, A
    mov   A, @R0
    xrl   A, SnSum
    mov   BootKey+3, A       ;BootKey[3] = cmdbuffer[3+i*6] ^ SnSum;
    mov   A, _i
    mov   B, #3              ;
    mul   AB
    add   A, #cmdbuffer+3    ;
    mov   R0, A
    mov   A, @R0
    xrl   A, SnSum
    mov   BootKey+4, A       ;BootKey[4] = cmdbuffer[3+i*3] ^ SnSum;
    mov   A, _i
    mov   B, #5              ;
    mul   AB
    add   A, #cmdbuffer+3    ;
    mov   R0, A
    mov   A, @R0
    xrl   A, SnSum
    mov   BootKey+6, A       ;BootKey[6] = cmdbuffer[3+i*5] ^ SnSum;
    mov   A, cmdbuffer+1
    mov   B, #5              ;
    div   AB
    mov   _i, A              ;i = cmdbuffer[1] / 5 
    add   A, #cmdbuffer+3    ;
    mov   R0, A
    mov   A, @R0
    xrl   A, SnSum
    mov   BootKey+1, A       ;BootKey[1] = cmdbuffer[3+i] ^ SnSum;
    mov   A, _i
    mov   B, #3              ;
    mul   AB
    add   A, #cmdbuffer+3    ;
    mov   R0, A
    mov   A, @R0
    xrl   A, SnSum
    mov   BootKey+5, A       ;BootKey[5] = cmdbuffer[3+i*3] ^ SnSum;
    mov   A, CHIP_ID         ; 
    add   A, BootKey+0       
    mov   BootKey+7, A       ;BootKey[7] = CHIP_ID + BootKey[0];
    clr   A
    mov   _i, A              ;i=0;
    mov   _result, A         ;result=0;

code_3A52:                   ;for ( i=0;i<8; i++)
    mov   A, #BootKey+0      ;
    add   A, _i              ;
    mov   R0, A
    mov   A, @R0             ;  result += Bootkey[i] + result;
    add   A, _result
    mov   _result, A
    inc   _i
    cjne  _i, #8, code_3A52
    ljmp  FuncBreak          ; 
;*****************************
;<a8> <x> <x> <cfg> <x> <cfg data>
JumpFunction7:                         ;write Boot Options
    mov   A, cmdbuffer+3               ;if  (cmdbuffer[3] & 0x07 == 0x07)
    anl   A, #7                        
    xrl   A, #7                        
    jz    $+5                          ;{
    ljmp  FuncBreak                    
                                       
    anl   cmdbuffer+14, #0x7F          ;   cmdbuffer[14] = cmdbuffer[14] & 0x7F | 0x40;
    orl   cmdbuffer+14, #0x40          
    mov   _i, A                        ;   for (i=0;i < 10; i +=2)  
                                           
code_3A72:                             ;   {
    mov   A, _i                            
    add   A, #low  ROM_CFG_ADDR-8      ;      R6 R7 = BootOptions + i
    mov   R7, A                            
    clr   A                                
    addc  A, #high ROM_CFG_ADDR-8      ;   
    mov   R6, A                            
    mov   A, R6                            
    push  ACC                          ;      save it
    mov   A, R7                            
    push  ACC                          ;    
    mov   A, #cmdbuffer+6              ;      value = cmdbuffer[6+i]<< 8 | cmdbuffer[5+i]  
    add   A, _i                            
    mov   R0, A                            
    mov   A, @R0                           
    mov   R6, A                            
    mov   A, #cmdbuffer+5              ;      
    add   A, _i                            
    mov   R0, A                            
    mov   A, @R0                           
    mov   R5, A                        ;      result = WriteFlashCode(addr,value)
    mov   A, R6                        
    mov   R4, A                        
    pop   ACC                          
    mov   R7, A                        
    pop   ACC                          
    mov   R6, A                        
    lcall WriteFlashCode               ;
    xch   A, _result                        
    mov   A, R7                        
    xch   A, _result                        
    inc   _i                           
    inc   _i                           
    mov   A, _i                        
    clr   C                            
    subb  A, #0xA                      ; 
    jc    code_3A72                    
    ljmp  FuncBreak                    ;
    
;****************************
;<a7> <x> <x> <> <>
JumpFunction6:                         ;read cfg
    clr   A                            
    mov   _result, A                   ;result = 0
    mov   A, cmdbuffer+3               ;if (cmdbuffer[3] & 0x07 == 0x07)
    anl   A, #7                        
    xrl   A, #7                        
    jnz   code_3AEE                    ;{
    mov   _result, #7                  ;   result = 0x07
    mov   CAddr+0, #high ROM_CFG_ADDR-8; CAddr = BootOptions
    mov   CAddr+1, #low  ROM_CFG_ADDR-8
    mov   _i, A                        ;   for (i=0;i<0x0A i++) 
code_3AB8:                             ;   {
    mov   DPL, CAddr+1                 ;      R7=CBYTE[CAddr]
    mov   DPH, CAddr+0                 ;
    clr   A                            
    movc  A, @A+DPTR                   
    mov   R7, A                        
    mov   A, #low response             ;     Response[rLen]=R7
    add   A, rlen                      
    mov   DPL, A                       ;
    clr   A                            
    addc  A, #high response            
    mov   DPH, A                       ;
    mov   A, R7                        
    movx  @DPTR, A                     
    inc   CAddr+1                      ;     CAddr++  
    mov   A, CAddr+1                   
    jnz   code_3AD6                    
    inc   CAddr+0                      
code_3AD6:                             ;
    inc   rlen                         ;      rLen++
    inc   _i
    cjne  _i, #0x0A, code_3AB8         ;   }
    inc   rlen                         ;   rLen+2
    inc   rlen                         
    mov   DPTR, #response+10           ;   R7=response[10] & ~bBOOT_LOAD   
    movx  A, @DPTR                     
    anl   A, #not bBOOT_LOAD           ;   
    mov   R7, A
    movx  @DPTR, A
    mov   A, GLOBAL_CFG                ;   A = GLOBAL_CFG & bBOOT_LOAD 
    anl   A, #bBOOT_LOAD               
    orl   A, R7                        
    movx  @DPTR, A                     ;   response[10] = A | R7
code_3AEE:                             ;}
    mov   A, cmdbuffer+3               ;if (cmdbuffer[3] & 0x08)   
    jnb   ACC.3, code_3B12             ;{
    xch   A, _result                   ;   result |= 0x08;  
    orl   A, #8                        
    xch   A, _result                        
    clr   A                            ;   for (i=0;i<4 ;i++)
    mov   _i, A                        
code_3AF9:                             ;   {
    mov   A, _i                        
    mov   DPTR, #BLoaderVer             ;      
    movc  A, @A+DPTR                   
    mov   R7, A                        
    mov   A, #low response             ;      Response[rLen] = CBYTE[BLoaderVer+i];
    add   A, rlen                      
    mov   DPL, A                       ; 
    clr   A                            
    addc  A, #high response            
    mov   DPH, A                       ; 
    mov   A, R7                        
    movx  @DPTR, A                     
    inc   rlen                         ;      rLen++; 
    inc   _i                           
    cjne  _i, #4, code_3AF9            ;   }
code_3B12:                             ;}
    mov   A, cmdbuffer+3               ;if (cmdbuffer[3] & 0x10)
    jnb   ACC.4, code_3B53             ;{
    xch   A, _result                        
    orl   A, #0x10                     ;   result |=0x10;
    xch   A, _result
    mov   CAddr+0, #high ROM_CHIP_ID_LO 
    mov   CAddr+1, #low  ROM_CHIP_ID_LO 
    clr   A
    mov   SnSum, A                     ;   snSum=0;
    mov   _i, A                        ;   for (i=0; i<4 ;i ++)
code_3B25:          ;                  
    mov   DPL, CAddr+1                 ;   {
    mov   DPH, CAddr+0                 ; 
    clr   A                            ;       R7=CBYTE[addr]
    movc  A, @A+DPTR                   
    mov   R7, A                        
    mov   A, #low response             ;       response[rLen] = R7
    add   A, rlen                      
    mov   DPL, A                       ; 
    clr   A                            
    addc  A, #high response            
    mov   DPH, A                       ; 
    mov   A, R7                        ;       SnSum+= response[rLen];
    movx  @DPTR, A                     
    inc   rlen                         ;       rLen++;
    add   A, SnSum                     
    mov   SnSum, A                     
    inc   CAddr+1                      ;       addr ++;
    mov   A, CAddr+1                   
    jnz   code_3B49                    
    inc   CAddr+0                      
code_3B49:        ;                    
    inc   _i                           
    cjne  _i, #4, code_3B25            ;   }  
    mov   A, #4                        ;   rLen+=4;
    add   A, rlen                      
    mov   rlen, A                      
code_3B53:                             ;}
    mov   SAFE_MOD, #0x55              ;SAFE_MOD = 0x55;
    mov   SAFE_MOD, #0xAA              ;SAFE_MOD = 0xAA;
    mov   GLOBAL_CFG, #0xC             ;GLOBAL_CFG = bCODE_WE | bDATA_WE
    clr   A                            ;
    mov   SAFE_MOD, A                  ;SAFE_MOD=0;
    sjmp  FuncBreak                    ;break
;****************************
;<a2> <x> <x> <param>
JumpFunction1:                         ;
    mov   A, cmdbuffer+3               ; if (cmdbuffer[3]==1) 
    cjne  A, #1, code_3B6A             
    setb  bSoftReset                   ;    bSoftReset=1;
    sjmp  code_3B6C                    
                                       
code_3B6A:                             ;
    setb  bWrProtect                   ;else bWrProtect=1; 
                                       
code_3B6C:                             ;
    clr   A                            ;result=0
    mov   _result, A
;****************************
FuncBreak:                             ;
    mov   DPTR, #Response              ;
    mov   A, cmdbuffer+0               ;Response[0]= cmdbuffer[0]
    movx  @DPTR, A                     
    mov   A, rlen                      
    add   A, #0xFC                     ; 
    mov   DPTR, #Response+2            ;Response[2]= rlen - 4
    movx  @DPTR, A                     
    clr   A                            
    inc   DPTR                         ;Response[3]= 0;
    movx  @DPTR, A                     
    inc   DPTR                         
    mov   A, _result                   ;Response[4]= result
    movx  @DPTR, A                     
    clr   A                            
    mov   Marker1, A                   ;clear all markers
    mov   Marker0, A                   
Dispatcher_Done:
    ret

; =============== S U B R O U T I N E =======================================
HandleUsbEvents:                       ; 0x3B88
    jb    UIF_TRANSFER, code_3B8E      ; 
    ljmp  usb_reset

code_3B8E:                             ; get the UIF_TRANSFER source
    mov   A, USB_INT_ST                ; 
    anl   A, #0x3F                     ;masktoken | maskep
    jnz   $+5
    ljmp  EP0OutTransfer                             ;
    add   A, #0xE0                     ;
    jnz   $+5
    ljmp  Ep0InTransfer                ;UIS_TOKEN_IN | 0                          ;
    add   A, #0xFE                     ;
    jz    EP2InTransfer                ;UIS_TOKEN_IN | 2
    add   A, #0xF2                     ;
    jz    SetupPacket                  ;UIS_TOKEN_SETUP | 0   
    add   A, #0x2E                     ;
    jz    Ep2OutTransfer               ;UIS_TOKEN_OUT | 2
    ljmp  transfer_done
;**************************************
Ep2OutTransfer:                        ;3BAD:
    jb    U_TOG_OK, code_3BB3          ;
    ljmp  transfer_done
;**************************************
code_3BB3:                             ;
    mov   RAM_09, USB_RX_LEN           ; 
    mov   RAM_0D+0, #1                 ;source xdata
    mov   RAM_0D+1, #high EP2_BUFFER
    mov   RAM_0D+2, #low  EP2_BUFFER
    mov   RAM_10, RAM_09
    mov   R3, #0                       ;dest idata
    mov   R2, #high cmdbuffer
    mov   R1, #low  cmdbuffer          ;
    lcall memcpy
    mov   Marker1, #0x5A               ;
    lcall FunctionDispatcher
    mov   UEP2_T_LEN, rlen             ;len 
    anl   UEP2_CTRL, #0xFC             ; 
    ljmp  transfer_done
;**************************************
EP2InTransfer:                         ;3BDA
    mov   A, UEP2_CTRL                 ; 
    anl   A, #0xFC
    orl   A, #2
    mov   UEP2_CTRL, A                 ; 
    ljmp  transfer_done
;**************************************
SetupPacket:                           ;3BE5
;   ANL     UEP0_CTRL,#0F2H            ;_changed_ stallbug  
    mov   A, USB_RX_LEN                ; 
    xrl   A, #8
    jnz   code_3C54
    mov   DPTR, #6                     ;
    movx  A, @DPTR
    mov   reqlen, A                    ; 
    clr   bReqError                    ;
    mov   DPTR, #0                     ;if brequesttype & typemask)
    movx  A, @DPTR
    anl   A, #0x60
    jz    StdRequest                   ;   
    setb  bReqError
    sjmp  Setup_break                  ;break 

StdRequest:                            ;3BFF
    mov   DPTR, #1                     ;brequest= Ep0Buffer[1]
    movx  A, @DPTR
    mov   bRequest, A                  ;
    mov   A, bRequest
    add   A, #0xFB                     ; ''
    jz    Set_Address
    add   A, #0xFD                     ; ''
    jz    GetConfig
    dec   A
    jz    SetConfig
    add   A, #3
    jnz   Setup_default
    mov   DPTR, #3
    movx  A, @DPTR
    add   A, #0xFE                     ; ''
    jz    GetConfigDesc
    inc   A
    jnz   DescUnknown
GetDeviceDesc:
    mov   DescAddr+0, #HIGH DeviceDesc
    mov   DescAddr+1, #LOW  DeviceDesc
    mov   RAM_09, #0x12
    sjmp  Setup_break
GetConfigDesc:                         ;3C2C
    mov   DescAddr+0, #HIGH ConfigDesc 
    mov   DescAddr+1, #LOW  ConfigDesc
    mov   RAM_09, #0x20 ;
    sjmp  Setup_break
DescUnknown:                           ;3C37
    setb  bReqError
    sjmp  Setup_break

Set_Address:                           ;3C3B
    sjmp  SetConfig

GetConfig:                             ;3C3D
    mov   DPTR, #0
    mov   A, wValueLo
    movx  @DPTR, A
    mov   RAM_09, #1
    sjmp  Setup_break

SetConfig:                             ;3C48
    mov   DPTR, #2
    movx  A, @DPTR
    mov   wValueLo, A
    sjmp  Setup_break

Setup_default:                         ;3C50
    setb  bReqError
    sjmp  Setup_break

code_3C54:        ;
    setb  bReqError

Setup_break:                           ;3C56:
    jnb   bReqError, next_packet
    mov   bRequest, #0xFF
    mov   UEP0_CTRL, #bUEP_R_TOG or bUEP_T_TOG or UEP_R_RES_STALL or UEP_T_RES_STALL; 0xCF ;
    sjmp  transfer_done

next_packet:                           ;3C61
    mov   A, reqlen
    setb  C
    subb  A, RAM_09
    jc    code_3C6B
    mov   reqlen, RAM_09
code_3C6B:                             ;
    lcall PrepareDescPacket
    mov   UEP0_CTRL, #bUEP_R_TOG or bUEP_T_TOG;0xC0 ;
    sjmp  transfer_done

;**************************************
Ep0InTransfer:                         ;3C73
    mov   A, bRequest
    add   A, #0xFB                     ; ''
    jz    status_address
    dec   A
    jnz   ep0In_default
    lcall PrepareDescPacket
    xrl   UEP0_CTRL, #0x40 ;
    sjmp  transfer_done

status_address:                        ;3C84
    mov   A, USB_DEV_AD                ;
    anl   A, #0x80
    orl   A, wValueLo
    mov   USB_DEV_AD, A                ;
    sjmp  EP0OutTransfer
ep0In_default:                         ;3C8E
    clr   A
    mov   UEP0_T_LEN, A                ;send a ZLP 
    sjmp  EP0OutTransfer

;**************************************
EP0OutTransfer:                        ;3C93
    mov   UEP0_CTRL, #UEP_T_RES_NAK    ;

transfer_done:
    clr   UIF_TRANSFER                 ;
    ret

;check other Irqs
usb_reset:
    jnb   UIF_BUS_RST, usb_suspend 
    mov   UEP0_CTRL, #UEP_T_RES_NAK    ; 
    mov   UEP2_CTRL, #0x12             ; 
    clr   A
    mov   USB_DEV_AD, A                ;
    sjmp  usb_done

usb_suspend:
    jnb   UIF_SUSPEND, usb_done        ; 
    clr   UIF_SUSPEND                  ; 
    ret
;we are done
usb_done:                              ;3CAD
    mov   USB_INT_FG, #0xFF            ; 
    ret

; ===========================================================================
; void main (void)
; ===========================================================================
main:    
;local vars 
_loops    set RAM_08          ;
_pins     set R6
_cfg      set R7
    mov   SAFE_MOD, #0x55     ;SAFE_MOD = 0x55;
    mov   SAFE_MOD, #0xAA     ;SAFE_MOD = 0xAA;
    mov   A, CLOCK_CFG        ;
    anl   A, #0xF8            ;  
    orl   A, #4               ;
    mov   CLOCK_CFG, A        ;
    clr   bSoftReset          ;
    setb  bWrProtect          ;
    mov   A, CHIP_ID          ;  odd numbers only have one serial
    rrc   A                   ;
    mov   bFirstSer, C        ;

    clr   EA
    clr   TR0                 ;
    clr   TF0                 ;
    jnb   bFirstSer, code_3CE7;if(bFirstSer) {
    mov   SCON, #0x50         ;  SCON=0x50;
    clr   A
    mov   T2CON, A            ;  T2CON=0;
    mov   PCON, #0x80         ;  PCON  = SMOD;
    mov   TMOD, #0x20         ;  TMOD  = 0x20;
    mov   T2MOD,#0xA0         ;  T2MOD = bTMR_CLK | bT1_CLK;
    mov   TH1,  #0xF3         ;  TH1   = 0xF3; 
    setb  TR1                 ;  TR1   = 1; 
    sjmp  code_3CED           ;} else
code_3CE7:                    ;{
    mov  SCON1, #0x30         ;   SCON1 = 30;
    mov  SBAUD1,#0xF3         ;   SBAUD = 0xF3;

code_3CED:                    ;}
    mov  DPTR, #0x3FF4        ;PortConfig ??
    clr  A
    movc A, @A+DPTR
    mov  _cfg, A              ;
    jnb  ACC.1, code_3CFD     ; Accumulator
    mov  C, UDP               ; Port 3
    clr  A
    rlc  A
    mov  _pins, A
    sjmp code_3D06

code_3CFD:                    ;
    jnb  MOSI, code_3D04      ; Port 1
    mov  _pins, #0
    sjmp code_3D06

code_3D04:                    ;
    mov   _pins, #1

code_3D06:                    ;
    mov   A, _pins
    jnz   init_usb
    mov   A, GLOBAL_CFG       ;
    jnb   ACC.5, init_usb     ;
    mov   DPTR, #0
    clr   A
    movc  A, @A+DPTR
    cjne  A, #0xFF, code_3D39
    inc   DPTR
    clr   A
    movc  A, @A+DPTR
    cjne  A, #0xFF, code_3D39

init_usb:
    clr   A                   ;
    mov   USB_CTRL, A         ;USB_CTRL=0;
    mov   UEP2_3_MOD, #0x0C   ;0x0C;
    mov   UEP0_DMA_H, A       ;UEP0_DMA=0; 
    mov   UEP0_DMA_L, A       ;
    mov   UEP2_DMA_H, A       ;UEP2_DMA=0x000C
    mov   UEP2_DMA_L, #low EP2_BUFFER;
    mov   USB_CTRL,   #0x29   ;USB_CTRL   = bUC_DEV_PU_EN | bUC_INT_BUSY | bUC_DMA_EN;
    mov   UDEV_CTRL,  #0x81   ;UDEV_CTRL  = bUD_PD_DIS | bUD_PORT_EN;
    mov   USB_INT_FG, #0xFF   ;USB_INT_FG = 0xFF;
    mov   USB_INT_EN, #7      ;USB_INT_EN = bUIE_SUSPEND | bUIE_TRANSFER | bUIE_BUS_RST;
    sjmp  code_3D4C

code_3D39:                    ;
    mov   A, _cfg             ;   
    jnb   ACC.0, code_3D4A    ;
    orl   TMOD, #1            ; Timer0 16 Bit timer 
    mov   TL0, #low  0x64C0   ; 0x64C0
    mov   TH0, #high 0x64C0   ;
    setb  TR0                 ; Timer 0/1 Control Register
    sjmp  code_3D4C

code_3D4A:                    ;
    setb  bSoftReset          ;active

code_3D4C:                    ;
    clr   A
    mov   _loops, A           ; loops=0

;Bootkey={0xA5,0xF6,0x7F,0x23,0x1D,0xC1,0xD3,0x43};
InitLoop:                     ;0x3D4F
    lcall Scrambled           ; 
    mov   A, #BootKey+0       ;
    add   A, _loops
    mov   R0, A
    xch   A, @R0
    mov   A, R7
    xch   A, @R0
    inc   _loops
    mov   A, _loops
    clr   C
    subb  A, #8              ;while (loops < 8) 
    jc    InitLoop

mainloop:                    ;while(1) {
    jnb   bSoftReset, code_3D71;  if (bSoftReset) {
    mov   SAFE_MOD, #0x55    ;    SAFE_MOD=    0x55
    mov   SAFE_MOD, #0xAA    ;    SAFE_MOD   = 0xAA
    mov   GLOBAL_CFG, #0x10  ;    GLOBAL_CFG = bSW_RESET;
    sjmp  $                  ;    while(1);
code_3D71:                   ;}else 
    jb    U1RI, code_3D77    ;{   
    jnb   RI, code_3D7D      ;  if ((!U1RI) & (RI))  
code_3D77:                   ;  {
    mov   Marker0, #0x96      ; 
    lcall SerialDispatcher   ;     SerialDispatcher();
code_3D7D:                   ;  }
    mov   A, USB_INT_FG      ;  if (USB_INT_FG & 0x07) 
    anl   A, #7              ;
    jz    code_3D89          ;  {
    mov   Marker0, #0x96      ; 
    lcall HandleUsbEvents    ;     HandleUsbEvents();
code_3D89:                   ;  }
    jnb   TF0, mainloop      ;  if (TF0) continue;
    clr   TF0                ;  TF0=0
    clr   TR0                ;  TR0=0;
    setb  bSoftReset         ;  bSoftReset=1;
    sjmp  mainloop           ;}

; =============== S U B R O U T I N E =======================================
;uint8_t SerialDispatcher(void)
;  uint8_t ch 
;  uint8_t chk;
;  uint8_t i; 
SerialDispatcher:            ; 0x3D94
_ch       SET R7
_chk      SET R6
_i        SET R5
    
    lcall SerialGetChar      ; 
    mov   A, _ch             ; if (SerialGetChar()!=0x57) return ;
    xrl   A, #0x57
    jnz   Serial_done        ; 
    lcall SerialGetChar      ; 
    mov   A, _ch             ; if (SerialGetChar()!=0xAB) return;
    xrl   A, #0xAB
    jnz   Serial_done        ; 
    lcall SerialGetChar      ; 3. char
    mov   cmdbuffer+0, _ch   ; buffer[0] = SerialGetChar();
    mov   _chk, cmdbuffer+0  ; chk = buffer[0]
    lcall SerialGetChar      ; 4. char
    mov   cmdbuffer+1, _ch   ; buffer[1] = SerialGetChar();
    mov   A, cmdbuffer+1       
    add   A, _chk            ; chk += buffer[1]
    mov   _chk, A
    lcall SerialGetChar      ; 5. char
    mov   cmdbuffer+2, _ch   ; buffer[2] = SerialGetChar();
    clr   A
    mov   _i, A              ; for (i=0;i< buffer[1];i++) 

code_3DBB:                   ;{
    mov   A, _i              ;   //recive loop
    xrl   A, cmdbuffer+1
    jz    code_3DCE
    lcall SerialGetChar      ;   buffer[3+i] = SerialGetChar()
    mov   A, #cmdbuffer+3    ;          
    add   A, _i              ;
    mov   R0, A         
    mov   A, _ch
    mov   @R0, A
    add   A, _chk            ;   chk+= buffer[3+i];
    mov   _chk, A
    inc   _i                 ; 
    sjmp  code_3DBB          ;}

code_3DCE:                   ;
    lcall SerialGetChar      ;if (SerialGetChar() != chk) exit 
    mov   A, _ch
    xrl   A, _chk
    jnz   Serial_done        ; exit
    clr   TR0                ; TF0=0;
    clr   TF0                ; TF0=0;
    mov   Marker1, #0x5A     ;  
    lcall FunctionDispatcher ; 
    clr   A
    mov   _chk, A            ; chk=0; 
    mov   _ch, #0x55         ; SerialWriteChar(0x55)
    lcall SerialWriteChar
    mov   _ch, #0xAA         ; SerialWriteChar(0xAA)
    lcall SerialWriteChar
    mov   _i, A              ;for (i=0;i<rLen;i++)   

code_3DEC:                   ;{
    mov   A, _i              ;   //sendloop
    clr   C
    subb  A, rlen
    jnc   code_3E11
    mov   A, #low  Response  ;   SerialWriteChar(Response[i])
    add   A, _i
    mov   DPL, A             ; 
    clr   A
    addc  A, #high Response
    mov   DPH, A             ; 
    movx  A, @DPTR
    mov   _ch, A
    lcall SerialWriteChar
    mov   A, #low  Response   ;  chk+=Response[i];
    add   A, _i
    mov   DPL, A              ;
    clr   A
    addc  A, #high Response
    mov   DPH, A              ;
    movx  A, @DPTR
    add   A, _chk
    mov   _chk, A           
    inc   _i
    sjmp  code_3DEC           ;}

code_3E11:                    ;
    xch   A, _ch
    mov   A, _chk             ;SerialWriteChar(chk)
    xch   A, _ch
    lcall SerialWriteChar     ;

Serial_done:
    ret
; =============== S U B R O U T I N E =======================================
;uint8_t Scrambled (void);
Scrambled:              ;0x3E18
    mov   R4, RAM_11    ;long
    mov   R5, RAM_11+1
    mov   R6, RAM_11+2
    mov   R7, RAM_11+3
    mov   R0, #0x10     ;16 times
    mov   A, R4         ;if(tmp==0) 
    orl   A, R5
    orl   A, R6
    orl   A, R7
    jnz   code_3E2C     ;{ 
    mov   R4, #0xA5     ;   tmp = 0xA5A5 << 16  
    mov   R5, #0xA5     ;} 
code_3E2C:              ;do 
    clr   C             ;{
    mov   A, R4         ;   tmp >>= 1
    rrc   A
    mov   R4, A
    mov   A, R5
    rrc   A
    mov   R5, A
    mov   A, R6
    rrc   A
    mov   R6, A
    mov   A, R7
    rrc   A
    mov   R7, A
    jnc   code_3E4B
    mov   A, R4
    xrl   A, #0xCC
    mov   R4, A
    mov   A, R5
    xrl   A, #0x4C
    mov   R5, A
    mov   A, R6
    xrl   A, #0x4E
    mov   R6, A
    mov   A, R7
    xrl   A, #0xCE
    mov   R7, A
code_3E4B:        ;
    djnz  R0, code_3E2C
    mov   RAM_11+0, R4
    mov   RAM_11+1, R5
    mov   RAM_11+2, R6
    mov   RAM_11+3, R7
    mov   A, R6
    anl   A, #0x7F
    mov   R6, A
    ret

; =============== S U B R O U T I N E =======================================
; not in use
code_3E5A:
    mov   RAM_11+0, R6
    mov   RAM_11+1, R7
    mov   A, #0xA5 ; ''
    mov   RAM_11+2, A
    mov   RAM_11+3, A
    ret

; ---------------------------------------------------------------------------
CopyrightMsg:                 ;0x3665
                db  'MCU ISP & WCH.CN',0 ;

DeviceDesc:                   ;0x3E76
                db    18
                db     1
                db  0x10,0x01 ; USB_bcd 1.1
                db  0xFF      ; class vendor defined  
                db  0x80      ; subclass ??
                db  0x55      ; protocol ??
                db     8      ; EP0 Size 
                db  0x48,0x43 ; Vendor ID 0x4843
                db  0xE0,0x55
                db  0x00,0x02 ; _changed_ to V2.0  
                db     0
                db     0
                db     0
                db     1

ConfigDesc:                  ;0x3E88
                db     9
                db     2
                db  0x20,0x00;
                db     1     ; 1 interface
                db     1     ; config 
                db     0     ; no string 
                db  0x80     ; buspower
                db  0x32     ; 100 mA
                
InterfaceDesc:  db     9
                db     4
                db     0
                db     0
                db     2     ; 2 EndPoints  
                db  0xFF     ; vendor 
                db  0x80     ; subclass 
                db  0x55     ; protocoll
                db     0

EndPointDesc:                 ;0x3E9A
                db     7
                db     5
                db  0x82      ; EP2 IN   
                db     2      ; bulk
                db  0x40,0x00 ; size
                db     0
                
                db     7
                db     5
                db     2      ; EP2 Out
                db     2      ; bulk
                db  0x40,0x00 ; size
                db     0
;what is this ????            ;4 extra bytes 
BLoaderVer:
code_3EA8:
                db     0      ;version 02.31 in BCD 
                db     2
                db     3
                db     1

; =============== S U B R O U T I N E =======================================
;uint8_t WriteFlashCode(uint16_t Address uint16 Data)
WriteFlashCode:            ;0x3EAC:
    mov   A, Marker0       ;
    xrl   A, #0x96
    jz    $+4
    sjmp  $
;if ( (Address < BOOT_LOAD_ADDR) || ((Address >= BootOptions ) && (Address < ROM_CFG_ADDR)))
    clr   C                ; 
    mov   A, R6
    subb  A, #high BOOT_LOAD_ADDR  ;
    jc    code_3ECB        ;
    mov   A, R7            ; 
    subb  A, #low  ROM_CFG_ADDR-8  ;
    mov   A, R6
    subb  A, #high ROM_CFG_ADDR-8  ;
    jc    code_3EE1        ;   
    setb  C
    mov   A, R7            ;
    subb  A, #low  ROM_CFG_ADDR  ;
    mov   A, R6
    subb  A, #high ROM_CFG_ADDR  ;
    jnc   code_3EE1

code_3ECB:                 ; AddressRange ok
    mov   ROM_ADDR_H, R6   ; ROM_ADDR = Address
    mov   ROM_ADDR_L, R7   ;
    mov   ROM_DATA_H, R4   ; ROM_DATA = Data
    mov   ROM_DATA_L, R5   ;
    mov   A, ROM_CTRL      ;
    jnb   ACC.6, code_3EE1  ;
    mov   ROM_CTRL, #ROM_CMD_WRITE 
    mov   A, ROM_CTRL      ;
    xrl   A, #0x40
    mov   R7, A
    ret
code_3EE1:                 ; return error
    mov   R7, #0x40        ;
    ret

; =============== S U B R O U T I N E =======================================
PrepareDescPacket:          ;0x3EE4
    mov   A, reqlen
    clr   C
    subb  A, #8
    jc    code_3EEF
    mov   R7, #8
    sjmp  code_3EF1

code_3EEF:                  ;
    mov   R7, reqlen        ; len

code_3EF1:                  ;
    xch   A, R6
    mov   A, R7
    xch   A, R6
    mov   RAM_0D+0, #0xFF      ; cmem
    mov   RAM_0D+1, DescAddr+0   ; addr
    mov   RAM_0D+2, DescAddr+1
    mov   RAM_10, R6
    mov   R3, #1            ; xmem
    mov   R2, #0            ; 0x000
    mov   R1, #0
    lcall memcpy
    clr   C
    mov   A, reqlen
    subb  A, R6
    mov   reqlen, A
    mov   A, R6
    add   A, DescAddr+1
    mov   DescAddr+1, A
    clr   A
    addc  A, DescAddr+0
    mov   DescAddr+0, A
    mov   UEP0_T_LEN, R6    ;
    ret

; =============== S U B R O U T I N E =======================================
; c runtime memcpy
memcpy:                      ; 0x3F1B
    mov   RAM_0A+0, R3       ; save ptr
    mov   RAM_0A+1, R2
    mov   RAM_0A+2, R1

code_3F21:                   ; loop
    mov   R7, RAM_10
    dec   RAM_10
    mov   A, R7
    jz    code_3F4E          ; done

    mov   R3, RAM_0D+0
    inc   RAM_0D+2
    mov   A, RAM_0D+2        ;RamE/F++
    mov   R2, RAM_0D+1
    jnz   code_3F34
    inc   RAM_0D+1
code_3F34:                   ;
    dec   A
    mov   R1, A
    lcall loadFromPtr        ;
    mov   R7, A
    mov   R3, RAM_0A+0
    inc   RAM_0A+2
    mov   A, RAM_0A+2
    mov   R2, RAM_0A+1
    jnz   code_3F46
    inc   RAM_0A+1

code_3F46:                   ;
    dec   A
    mov   R1, A
    mov   A, R7
    lcall storeToPtr
    sjmp  code_3F21          ; goto loop

code_3F4E:                   ; done
    ret

; =============== S U B R O U T I N E =======================================
;c runtime  loadFromPtr
loadFromPtr:                  ; 0x3F4F
    cjne  R3, #1, code_3F58
    mov   DPL, R1             ;
    mov   DPH, R2             ;
    movx  A, @DPTR
    ret
code_3F58:                    ; from idata
    jnc   code_3F5C
    mov   A, @R1
    ret
code_3F5C:                    ; from xdata
    cjne  R3, #0xFE, code_3F61;
    movx  A, @R1
    ret
code_3F61:                    ; from code
    mov   DPL, R1             ;
    mov   DPH, R2             ;
    clr   A
    movc  A, @A+DPTR
    ret

; =============== S U B R O U T I N E =======================================
;c runtime
storeToPtr:                   ;0x3F68
    cjne  R3, #1, code_3F71   ;
    mov   DPL, R1             ;
    mov   DPH, R2             ;
    movx  @DPTR, A
    ret
code_3F71:                    ; to idata
    jnc   code_3F75
    mov   @R1, A
    ret
code_3F75:                    ;
    cjne  R3, #0xFE, code_3F79;
    movx  @R1, A
code_3F79:                    ;
    ret
; =============== S U B R O U T I N E =======================================
;uint8_t WriteFlashData(uint8_t Address,unt8_t value);
WriteFlashData:               ; 0x3F7A
    mov   A, Marker0
    xrl   A, #0x96
    jz    code_3F82
    sjmp  $

code_3F82:                    ;
    mov   ROM_ADDR_H, #high DATA_FLASH_ADDR
    mov   A, R7
    add   A, ACC              ;
    mov   ROM_ADDR_L, A       ;
    mov   ROM_DATA_L, R5      ;
    mov   A, ROM_CTRL         ;
    jnb   ACC.6, code_3F9A    ;
    mov   ROM_CTRL, #0x9A     ;
    mov   A, ROM_CTRL         ;
    xrl   A, #0x40
    mov   R7, A
    ret
code_3F9A:                    ;
    mov R7, #0x40             ;
    ret
; =============== S U B R O U T I N E =======================================
;void SerialWriteChar(uint8_t Send);
SerialWriteChar:              ;0x3F9D
    jnb  bFirstSer, code_3FAA
    clr  TI                   ;
    mov  SBUF, R7             ; send the char
    jnb  TI, $                ; wait until send
    clr  TI                   ;
    ret
code_3FAA:                    ;
    clr  U1TI                 ;
    mov  SBUF1, R7            ; Send the char
    jnb  U1TI,$               ; wait until send
    clr  U1TI                 ;
    ret
; =============== S U B R O U T I N E =======================================
;uint8_t SerialGetChar (void)
SerialGetChar:                ;0x3FB4
    jnb  bFirstSer, code_3FBF
    jnb  RI, $                ; wait for a char
    clr  RI                   ;
    mov  R7, SBUF             ; and return it
    ret
code_3FBF:                    ;
    jnb   U1RI, $             ; wait for a char
    clr   U1RI                ;
    mov   R7, SBUF1           ; and return it
    ret

; =============== S U B R O U T I N E =======================================
C_C51STARTUP:                 ;
    mov   R0, #0x7F           ;
    clr   A
IDATALOOP:                    ;Init idata
    mov   @R0, A
    djnz  R0, IDATALOOP
    mov   SP, #STACK-1        ;Stack Pointer
    ljmp  main                ;start with main

cseg at StartAddress or  0x7EE
    dw    0xFFFF
        
; ===========================================================================
;cseg at 0x3FF0               ;boot options
;BootOptions:
;     db 0xFF
;     db 0xFF
;     db 0xFF
;     db 0xFF
;0x3FF4
;     db 0x03
;     db 0x00
;     db 0x00
;     db 0x00         
end ;
